Ext.define('DSS.component.TitterMessageEditor', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    height : 140,
    txtTwitterAccount : null,
    txtBody : null,
    padding : "0 0 0 10",
    constructor : function(config) {
    	var me = this;
    	this.txtTwitterAccount = Ext.create('Ext.form.field.Display', {
    		border : 0,
    		fieldLabel : _('Send on behalf of'),
    		height : 20,
    		width : 750,
            labelWidth : 200
    	});

        this.txtBody = Ext.create('DSS.component.TextAreaedit', {
            fieldLabel : _('Message'),
            width : 750,
            height : 40,
            labelWidth : 200,
            maxLength : 107, // 140 characters -"#mydigitalStrom" - timestamp
            blankText : _('A message must be provided'),
            invalidText : _('A message must be provided'),
            maxLengthText : _('The maximum number of characters exceeded'),
            enableKeyEvents: true,
            listeners: {
                keyup:function () 
                {
                	me.countChars();
                }
            }

        });
        
        this.txtCounter = Ext.create('Ext.form.field.Display', {
    		border : 0,
    		fieldLabel : _('Characters left'),
    		height : 20,
    		width : 750,
            labelWidth : 200,
            id : 'counter'
    	});
        
        this.txtHint = Ext.create('Ext.form.field.Display', {
    		border : 0,
    		fieldLabel : _('Please note'),
    		height : 20,
    		width : 750,
            labelWidth : 200
    	});
        
        var oControlGroup = Ext.create('Ext.form.FieldSet', {
            title : config.title,
            width : "100%",
            items : [  this.txtTwitterAccount, this.txtBody, this.txtCounter, this.txtHint ]
        });

        Ext.apply(this, {
            items : [ this.txtTwitterAccount, this.txtBody, this.txtCounter, this.txtHint ]
        });
        this.callParent(arguments);
    },
    reset : function() {
    	var screenName = this.getScreenName();
    	this.txtTwitterAccount.setValue(screenName);
   		this.txtBody.reset();
   		this.countChars();
   		this.txtHint.setValue(_('#mydigitalstrom and a time stamp will be appended to your tweet'));
     },
    setValue : function(value) {
    	var screenName = this.getScreenName();
    	this.txtTwitterAccount.setValue(screenName);
        this.txtBody.setValue(value);
        this.countChars();
        this.txtHint.setValue(_('#mydigitalstrom and a time stamp will be appended to your tweet'));
    },
    isValid : function() {
        var fValid=false;

        this.txtBody.markInvalid();  
        var sBody = this.txtBody.getValue();
        if (sBody !=null)
            if (unescape(sBody).length > 0) {
            	if (unescape(sBody).length <= this.txtBody.maxLength) {
            		fValid=true;
            	} else {
            		this.txtBody.markInvalid(_('The maximum number of characters exceeded'));
            	}
            } else {
            	this.txtBody.markInvalid(_('A message must be provided'));
            }
        return fValid;
    },
    getValue : function() {
        var oObject = {};
        oObject.messageType = 'tweet';
        oObject.message = this.txtBody.getValue();
        if (oObject.message==null)
            oObject.message="";
        return oObject.message;
    },
    
    getScreenName : function() {
    	var userAccount = _('Not registered to a twitter user account');
    	var sString = dss.ajaxSyncRequest('/json/property/query', {
	        'query' : '/scripts/event-twitterer(screenName)'
	    });
	    var result = Ext.JSON.decode(sString);
	    if ((result.result!=null) && (result.result['event-twitterer']!=null)) {
    		if (result.result['event-twitterer'][0]!=null) {		
    			userAccount = "@" + result.result['event-twitterer'][0]['screenName'];
    		}
	    }
	    return userAccount;
    },
    
    countChars : function() {
  	  var remainingChar = this.txtBody.maxLength;
  	  var usedChar = 0;
  	  var sBody = this.txtBody.getValue();
  	  if (undefined != sBody) {
  	      
  		usedChar = unescape(sBody).length;
  	  }
  	  remainingChar = remainingChar - usedChar;
  	  this.txtCounter.setValue(remainingChar + "/140");
  	}
});

